// score: 70
// faster dp solution
// O(n B^2) and O(n + A B^3)
#include <bits/stdc++.h>
using namespace std;

constexpr int inf = 1e9;

int cdiv(int64_t a, int64_t b){
    assert(0 < b);
    if(a > 0) return (a + b-1)/b;
    return a/b;
}

template<typename T>
bool xmin(T&a, T const&b){
    if(b < a){
        a = b;
        return true;
    } else {
        return false;
    }
}

void solve(){
    int n, A, B;
    cin >> n >> A >> B;
    vector<int> v(n);
    int64_t add = 0;
    for(auto &e:v) {
        cin >> e;
        if(e > 2*A*B){
            int x = e/(A*B)-2;
            e -= x*A*B;
            add += x;
        }
    }
    sort(v.begin(), v.end());
    const int X = 2*B;
    vector<int64_t> dp(X, inf);
    auto dp2 = dp;
    dp[0] = 0;
    bool did = true;
    for(int i=0; i<n; ++i){
        fill(dp2.begin(), dp2.end(), inf);
        const int e = v[i];
        if(!did && e == v[i-1]) continue;
        did = false;
        for(int a=0; a <= min(B, e/A+1); ++a){
            const int b = (max(0, e-a*A)+B-1)/B;
            for(int x = 0; x < X-a; ++x){
                if(xmin(dp2[x+a], dp[x] + b)) did = true;
            }
        }
        // replace whole pizzas by whole pizzas
        for(int i=X-1; i>=B; --i){
            xmin(dp2[i-B], dp2[i] + A);
        }
        dp.swap(dp2);
    }
    int ans = inf;
    for(int i=0; i<X; ++i){
        xmin(ans, cdiv(dp[i], A) + cdiv(i, B));
    }
    cout << add+ans << "\n";
}

signed main(){
    int T=1;
    // cin >> T;
    while(T --> 0) solve();
}
