// score: 50
#include <cassert>
#include <cstdio>
#include <deque>
#include <vector>

int n, m, k, q;
std::vector<std::vector<int> > state;
std::vector<std::vector<int> > priv;

int c;
std::vector<int> comp;
std::vector<std::vector<int> > e;

void read_edges(int m, std::vector<std::vector<int> > &edges) {
    for (int i = 0; i < m; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
}

int bfs(int from, int to) {
    std::vector<int> dist(n, -1);
    dist[from] = 0;
    std::deque<int> deq;
    deq.push_front(from);
    while (!deq.empty() && dist[to] == -1) {
        int cur = deq.back();
        deq.pop_back();
        for (unsigned j = 0; j < e[cur].size(); j++) {
            int s = e[cur][j];
            if (dist[s] == -1) {
                dist[s] = dist[cur] + 1;
                deq.push_front(s);
            }
        }
    }
    return dist[to];
}

void dfs(int v) {
    comp[v] = c;
    for (unsigned j = 0; j < state[v].size(); j++) {
        int s = state[v][j];
        if (comp[s] == -1) dfs(s);
    }
}

int main() {
    scanf("%d%d%d%d", &n, &m, &k, &q);
    state.resize(n);
    read_edges(m, state);
    priv.resize(n);
    read_edges(k, priv);

    c = 0;
    comp.resize(n, -1);
    for (int i = 0; i < n; i++) {
        if (comp[i] == -1) {
            dfs(i);
            c++;
        }
    }
    assert(c - 1 <= k);
    e.resize(c);
    for (int i = 0; i < n; i++) {
        for (unsigned j = 0; j < priv[i].size(); j++) {
            int c1 = comp[i], c2 = comp[priv[i][j]];
            e[c1].push_back(c2);
        }
    }

    for (int i = 0; i < q; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        printf("%d\n", bfs(comp[u], comp[v]));
    }

    return 0;
}
