// score: 50
#include <cassert>
#include <cstdio>
#include <queue>
#include <vector>

int n, m, k, q;
std::vector<std::vector<std::pair<int, int> > > nex;

std::vector<std::vector<int> > d;

void read_edges(int m, int d) {
    for (int i = 0; i < m; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        nex[u].push_back(std::make_pair(v, d));
        nex[v].push_back(std::make_pair(u, d));
    }
}

void dijkstra(int from) {
    std::vector<int> dist(n, -1);
    dist[from] = 0;
    std::priority_queue<std::pair<int, int> > pq;
    pq.push(std::make_pair(0, from));
    while (!pq.empty()) {
        int d = -pq.top().first;
        int cur = pq.top().second;
        pq.pop();
        if (dist[cur] != -1 && dist[cur] < d) continue;
        assert(dist[cur] == -1 || dist[cur] == d);
        dist[cur] = d;
        for (unsigned j = 0; j < nex[cur].size(); j++) {
            int s = nex[cur][j].first;
            int d = nex[cur][j].second;
            if (dist[s] == -1 || dist[cur] + d < dist[s]) {
                dist[s] = dist[cur] + d;
                pq.push(std::make_pair(-dist[s], s));
            }
        }
    }
    d[from] = dist;
}

int main() {
    scanf("%d%d%d%d", &n, &m, &k, &q);
    nex.resize(n);
    read_edges(m, 0);
    read_edges(k, 1);

    d.resize(n);
    for (int i = 0; i < n; i++) dijkstra(i);

    for (int i = 0; i < q; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        printf("%d\n", d[u][v]);
    }

    return 0;
}
