// score: 100
#include <cassert>
#include <cstdio>
#include <deque>
#include <vector>

int n, m, k, q;
std::vector<std::vector<int> > state;
std::vector<std::vector<int> > priv;

int c;
std::vector<int> comp;
std::vector<std::vector<int> > e;
std::vector<std::vector<int> > d;

void read_edges(int m, std::vector<std::vector<int> > &edges) {
    for (int i = 0; i < m; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
}

void bfs(int from) {
    std::deque<int> deq;
    deq.push_front(from);
    d[from][from] = 0;
    while (!deq.empty()) {
        int cur = deq.back();
        deq.pop_back();
        for (unsigned j = 0; j < e[cur].size(); j++) {
            int s = e[cur][j];
            if (d[from][s] == -1) {
                d[from][s] = d[from][cur] + 1;
                deq.push_front(s);
            }
        }
    }
}

void dfs(int v) {
    comp[v] = c;
    for (unsigned j = 0; j < state[v].size(); j++) {
        int s = state[v][j];
        if (comp[s] == -1) dfs(s);
    }
}

int main() {
    scanf("%d%d%d%d", &n, &m, &k, &q);
    state.resize(n);
    read_edges(m, state);
    priv.resize(n);
    read_edges(k, priv);

    c = 0;
    comp.resize(n, -1);
    for (int i = 0; i < n; i++) {
        if (comp[i] == -1) {
            dfs(i);
            c++;
        }
    }
    assert(c - 1 <= k);
    e.resize(c);
    for (int i = 0; i < n; i++) {
        for (unsigned j = 0; j < priv[i].size(); j++) {
            int c1 = comp[i], c2 = comp[priv[i][j]];
            e[c1].push_back(c2);
        }
    }

    d.resize(c, std::vector<int>(c, -1));
    for (int i = 0; i < c; i++) {
        bfs(i);
    }
    for (int i = 0; i < c; i++) {
        for (int j = 0; j < c; j++) assert(d[i][j] != -1);
    }

    for (int i = 0; i < q; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        int c1 = comp[u], c2 = comp[v];
        printf("%d\n", d[c1][c2]);
    }

    return 0;
}
