#include <bits/stdc++.h>
using namespace std;

void dfs(vector<vector<int>> const& g, int v, int comp_id, vector<int>& component) {
  if (component[v] != -1) return;
  component[v] = comp_id;
  for (auto w : g[v])
    dfs(g, w, comp_id, component);
}

pair<int, vector<int>> compress(vector<vector<int>> const& g) {
  vector<int> component(g.size(), -1);
  int comp_id = 0;
  for (int i=0; i<(int)g.size(); ++i)
    if (component[i] == -1)
      dfs(g, i, comp_id++, component);
  return {comp_id, component};
}

vector<int> bfs(vector<vector<int>> const& g, int start) {
  vector<int> dist(g.size(), -1);
  queue<int> q;
  dist[start] = 0;
  q.push(start);
  while (!q.empty()) {
    auto v = q.front();
    q.pop();
    for (auto w : g[v]) {
      if (dist[w] == -1) {
        dist[w] = dist[v] + 1;
        q.push(w);
      }
    }
  }
  return dist;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);

  int n, m, k, q;
  cin >> n >> m >> k >> q;

  vector<vector<int>> g0(n); // graph of 0-edges
  for (int i=0; i<m; ++i) {
    int a, b; cin >> a >> b;
    g0[a].push_back(b);
    g0[b].push_back(a);
  }
  auto [num_components, component] = compress(g0);
  vector<vector<int>> g1(num_components); // graph of 1-edges
  for (int i=0; i<k; ++i) {
    int a, b; cin >> a >> b;
    a = component[a];
    b = component[b];
    if (a != b) {
      g1[a].push_back(b);
      g1[b].push_back(a);
    }
  }
  vector<vector<int>> dist(num_components);
  for (int s=0; s<num_components; ++s)
    dist[s] = bfs(g1, s);
  for (int i=0; i<q; ++i) {
    int a, b; cin >> a >> b;
    cout << dist[component[a]][component[b]] << '\n';
  }
}
